# -*- coding: UTF-8 -*-

from creole.cfgparser import EoleDict
from creole import config
from os.path import isfile
from creole.utils import stringify

def parse_dico():
    dictionnaire = {}
    dic = EoleDict(templatedir=config.templatedir,logfile='/dev/null')
    dic.read_dir(['/etc/eole/dicos/','/etc/eole/dicos/local/', '/etc/eole/dicos/variante/'])
    # lecture des valeurs actuelles si elles sont disponibles
    if isfile('/etc/eole/config.eol'):
        dic.load_values()
    masters = {}
    for maitre,esclaves in dic.groups.items():
        for esclave in esclaves:
            masters[esclave] = maitre
    for var in dic.variables.keys():
        # valeurs multi-valuee : liste, valeur simple : chaine !
        var = stringify(var)
        dictionnaire[var] = dic.get_value(var)
        if var in masters:
            if dic.variables[masters[var]].multi:
                continue
        if dic.variables[var].multi:
            continue
        if len(dictionnaire[var]) == 1:
            dictionnaire[var] = str(dictionnaire[var][0])
        elif len(dictionnaire[var]) == 0:
            dictionnaire[var] = ""
    return dictionnaire
